// File : pylibgrass5.i
// SWIG interface for libgrass5
//
// probably only useful to generate Python bindings.
//	swig -python -shadow shapelib.i
//
//	tested with swig1.3a5
//
//	Copyright ImageLinks
//	Author: Bernhard Reiter <bernhard@intevation.de>
//
//	This file is part of libgrass5 and free software under LGPL.

%module pylibgrass5
%{
#include "gis.h"
%}

%typemap(python,in) string_allows_none {
	if($source==Py_None) {
		$target=NULL;
	} else {
		$target=PyString_AsString($source);
		if(!$target) {
			return NULL;
		}
	}
}

%inline %{
typedef char * string_allows_none;
%}

int G_gisinit_2( char *, string_allows_none a=NULL, 
			 string_allows_none b=NULL, 
			 string_allows_none c=NULL );

%typemap(python,out) char ** {
	int len=0,i;
	PyObject * stringobject;

	if(!$source) {
		$target=PyList_New(0);
	} else {

		/* count number of elements first */
		for(len=0;$source[len];len++);

		$target=PyList_New(len);
		if(!$target){
			 G_free_list($source);
			 return NULL;
		}
			
		for(i=0;i<len;i++) {
			stringobject=PyString_FromString($source[i]);
			if(!stringobject) return NULL;
			PyList_SetItem($target,i,stringobject);
			/* no DECREF needed, because 
			/*    PyList_SetItems steals reference*/
		}
		G_free_list($source);
	}
}


char ** G_fetch_list_element( char *, string_allows_none mapset=NULL);
char ** G_fetch_list_locations( string_allows_none gisdbase=NULL );
char ** G_fetch_list_mapsets( string_allows_none location_path=NULL );

/* not wrapped, because mainly used internally
 *
char ** G_fetch_list_files( char * directory );
 */

/* We do not need to wrap  G_free_list and G_add_to_list
 * because we only use the python lists
 *
void    G_free_list( char ** );
char  **G_add_to_list( char **, char * );
 */

char *G_path_peel_element( char * );
int G_check_cell( char *name, char **ret_mapset=NULL, char **ret_cell=NULL );
int G_open_cell_old_2( char * );

int I_check_group( char *name, char **ret_mapset, char **ret_group );

char *G_get_cell_as_proj4( char *cell, char *mapset );
char *G_kv_to_proj4( struct Key_Value *in_proj_keys, 
                     struct Key_Value *in_units_keys );
int G_proj4_to_kv( char *proj4, 
                   struct Key_Value **out_proj_keys, 
                   struct Key_Value **out_units_keys );

int G__make_location( char *location_name, struct Cell_head *wind, 
    struct Key_Value *proj_info, struct Key_Value *proj_units,
    FILE *report_file );
void G_set_cellhd_from_projinfo( struct Cell_head *wind, 
                                 struct Key_Value *proj_info );

/* comp_proj.c */
int G_compare_projections( struct Key_Value *proj_info1, 
                       struct Key_Value *proj_units1, 
                       struct Key_Value *proj_info2, 
                       struct Key_Value *proj_units2 );

